/*Copyright (C) 2017 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <fstream>
#include <cstring>
#include <cstdlib>
#include <unistd.h>

#define BUFFERSIZE 100
#define KEYBOARDETALONFILENAME "/tmp/abashin.ru_keyboards_etalon"
#define MOUSEETALONFILENAME "/tmp/abashin.ru_mouses_etalon"
#define SAVEDATA "/.abashin.ru/save_data"
#define ETALONDATA "/.abashin.ru/etalon_data"
#define ETALON "/.abashin.ru/etalon"
#define ETALONDEFAULT "/.abashin.ru/etalon.default"
#define HUMANSTATUS "/.abashin.ru/human_status"
#define HUMANSTATUSLOG "/.abashin.ru/human_status_log"
#define PROGETALON "/usr/sbin/abashin.ru.etalon "
#define PROGHUMANSTATUS "/usr/sbin/abashin.ru.status "
#define PROGHUMANSTATUSREPORT "/usr/sbin/abashin.ru.report "
#define PROGSTATUSLOGSEND "/usr/sbin/abashin.ru.send "

using namespace std;

int main (int argc, char * argv[]) {
  int result = 0;
  string buff;

  ifstream ifile;
  buff = buff + getenv("HOME") + ETALONDEFAULT;
  ifile.open(buff, ifstream::in);
  if (ifile) {
    result = system("mkdir ~/.abashin.ru");
    if (!result) return 0;
  }
  ifile.close();

  buff.clear();
  buff = buff + PROGETALON + getenv("HOME") + SAVEDATA + " " +
    getenv("HOME") + ETALONDATA + " " + getenv("HOME") + ETALON;
  result = system(buff.c_str());

  buff.clear();
  buff = buff + getenv("HOME") + ETALON;
  ifile.open(buff);
  if (!ifile.is_open()) {
    buff.clear();
    buff = buff + "cp " + getenv("HOME") + ETALONDEFAULT + " " +
           getenv("HOME") + ETALON;
    result = system(buff.c_str());
  }
  else ifile.close();

  buff.clear();
  buff = buff + PROGHUMANSTATUS + " " + getenv("HOME") + SAVEDATA +
         " " + getenv("HOME") + ETALON + " " + getenv("HOME") +
         HUMANSTATUS + " " + getenv("HOME") + HUMANSTATUSLOG;

  while(1) {
    sleep(60);
    ifstream cur_etal_keyboard;
    cur_etal_keyboard.open(KEYBOARDETALONFILENAME, ifstream::in);
    char buffer [BUFFERSIZE] = {0};

    ofstream ofs;
    buff.clear();
    buff = buff + getenv("HOME") + SAVEDATA;
    ofs.open(buff, ofstream::out | ofstream::app);
    ofs << 0 << " " << time(NULL) << endl;
    cur_etal_keyboard.getline ((char *)&buffer,BUFFERSIZE-1);
    while (cur_etal_keyboard.good()) {
      ofs <<  1 << " " << (char *)&buffer << endl;
      cur_etal_keyboard.getline ((char *)&buffer,BUFFERSIZE-1);
    }
    cur_etal_keyboard.close();

    ifstream cur_etal_mouse;
    cur_etal_mouse.open(MOUSEETALONFILENAME, ifstream::in);
    cur_etal_mouse.getline ((char *)&buffer,BUFFERSIZE-1);
    ofs <<  2 << " " << (char *)&buffer << endl;
    cur_etal_mouse.getline ((char *)&buffer,BUFFERSIZE-1);
    while (cur_etal_mouse.good()) {
      ofs <<  2 << " " << (char *)&buffer << endl;
      cur_etal_mouse.getline ((char *)&buffer,BUFFERSIZE-1);
    }
    cur_etal_mouse.close();
    ofs.close();

    buff.clear();
    buff = buff + PROGHUMANSTATUS + " " + getenv("HOME") + SAVEDATA +
         " " + getenv("HOME") + ETALON + " " + getenv("HOME") +
         HUMANSTATUS + " " + getenv("HOME") + HUMANSTATUSLOG;
    result = system(buff.c_str());

    buff.clear();
    buff = buff + PROGHUMANSTATUSREPORT + " " + getenv("HOME") + HUMANSTATUSLOG;
    result = system(buff.c_str());

    buff.clear();
    buff = buff + PROGSTATUSLOGSEND + " " + getenv("HOME") + HUMANSTATUSLOG;
    result = system(buff.c_str());
  }
  return 0;
}
